package com.xmomen.module.base.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;
import java.util.ArrayList;
import java.util.List;

// 会员优惠券关系实体类
public class CdMemberCouponRelationExample extends BaseMybatisExample {
    // 排序字段
    protected String orderByClause;

    // 是否去重
    protected boolean distinct;

    // 查询条件
    protected List<Criteria> oredCriteria;

    // 构造函数
    public CdMemberCouponRelationExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    // 设置排序字段
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    // 获取排序字段
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置是否去重
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    // 获取是否去重
    public boolean isDistinct() {
        return distinct;
    }

    // 获取查询条件
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    // 添加查询条件
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    // 创建查询条件
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    // 创建查询条件
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 创建查询条件
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    // 清空查询条件
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    // 生成查询条件
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        // 判断查询条件是否有效
        public boolean isValid() {
            return criteria.size() > 0;
        }

        // 获取所有查询条件
        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        // 获取查询条件
        public List<Criterion> getCriteria() {
            return criteria;
        }

        // 添加查询条件
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        // 判断ID是否为空
        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        // 判断ID是否不为空
        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        // 判断ID是否等于某个值
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否不等于某个值
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否大于某个值
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否大于等于某个值
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否小于某个值
        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否小于等于某个值
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否在某个范围内
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        // 判断ID是否不在某个范围内
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        // 判断ID是否在某个范围内
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        // 判断ID是否不在某个范围内
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        // 判断会员ID是否为空
        public Criteria andCdMemberIdIsNull() {
            addCriterion("CD_MEMBER_ID is null");
            return (Criteria) this;
        }

        // 判断会员ID是否不为空
        public Criteria andCdMemberIdIsNotNull() {
            addCriterion("CD_MEMBER_ID is not null");
            return (Criteria) this;
        }

        // 判断会员ID是否等于某个值
        public Criteria andCdMemberIdEqualTo(Integer value) {
            addCriterion("CD_MEMBER_ID =", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否不等于某个值
        public Criteria andCdMemberIdNotEqualTo(Integer value) {
            addCriterion("CD_MEMBER_ID <>", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否大于某个值
        public Criteria andCdMemberIdGreaterThan(Integer value) {
            addCriterion("CD_MEMBER_ID >", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否大于等于某个值
        public Criteria andCdMemberIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("CD_MEMBER_ID >=", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否小于某个值
        public Criteria andCdMemberIdLessThan(Integer value) {
            addCriterion("CD_MEMBER_ID <", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否小于等于某个值
        public Criteria andCdMemberIdLessThanOrEqualTo(Integer value) {
            addCriterion("CD_MEMBER_ID <=", value, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否在某个范围内
        public Criteria andCdMemberIdIn(List<Integer> values) {
            addCriterion("CD_MEMBER_ID in", values, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否不在某个范围内
        public Criteria andCdMemberIdNotIn(List<Integer> values) {
            addCriterion("CD_MEMBER_ID not in", values, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否在某个范围内
        public Criteria andCdMemberIdBetween(Integer value1, Integer value2) {
            addCriterion("CD_MEMBER_ID between", value1, value2, "cdMemberId");
            return (Criteria) this;
        }

        // 判断会员ID是否不在某个范围内
        public Criteria andCdMemberIdNotBetween(Integer value1, Integer value2) {
            addCriterion("CD_MEMBER_ID not between", value1, value2, "cdMemberId");
            return (Criteria) this;
        }

        // 判断优惠券编号是否为空
        public Criteria andCouponNumberIsNull() {
            addCriterion("COUPON_NUMBER is null");
            return (Criteria) this;
        }

        // 判断优惠券编号是否不为空
        public Criteria andCouponNumberIsNotNull() {
            addCriterion("COUPON_NUMBER is not null");
            return (Criteria) this;
        }

        // 判断优惠券编号是否等于某个值
        public Criteria andCouponNumberEqualTo(String value) {
            addCriterion("COUPON_NUMBER =", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否不等于某个值
        public Criteria andCouponNumberNotEqualTo(String value) {
            addCriterion("COUPON_NUMBER <>", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否大于某个值
        public Criteria andCouponNumberGreaterThan(String value) {
            addCriterion("COUPON_NUMBER >", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否大于等于某个值
        public Criteria andCouponNumberGreaterThanOrEqualTo(String value) {
            addCriterion("COUPON_NUMBER >=", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否小于某个值
        public Criteria andCouponNumberLessThan(String value) {
            addCriterion("COUPON_NUMBER <", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否小于等于某个值
        public Criteria andCouponNumberLessThanOrEqualTo(String value) {
            addCriterion("COUPON_NUMBER <=", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否包含某个值
        public Criteria andCouponNumberLike(String value) {
            addCriterion("COUPON_NUMBER like", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否不包含某个值
        public Criteria andCouponNumberNotLike(String value) {
            addCriterion("COUPON_NUMBER not like", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否在某个范围内
        public Criteria andCouponNumberIn(List<String> values) {
            addCriterion("COUPON_NUMBER in", values, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否不在某个范围内
        public Criteria andCouponNumberNotIn(List<String> values) {
            addCriterion("COUPON_NUMBER not in", values, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否在某个范围内
        public Criteria andCouponNumberBetween(String value1, String value2) {
            addCriterion("COUPON_NUMBER between", value1, value2, "couponNumber");
            return (Criteria) this;
        }

        // 判断优惠券编号是否不在某个范围内
        public Criteria andCouponNumberNotBetween(String value1, String value2) {
            addCriterion("COUPON_NUMBER not between", value1, value2, "couponNumber");
            return (Criteria) this;
        }
    }

    // 生成查询条件
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    // 生成查询条件
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        // 获取查询条件
        public String getCondition() {
            return condition;
        }

        // 获取查询条件的值
        public Object getValue() {
            return value;
        }

        // 获取查询条件的第二个值
        public Object getSecondValue() {
            return secondValue;
        }

        // 判断查询条件是否为空
        public boolean isNoValue() {
            return noValue;
        }

        // 判断查询条件是否为单个值
        public boolean isSingleValue() {
            return singleValue;
        }

        // 判断查询条件是否为范围值
        public boolean isBetweenValue() {
            return betweenValue;
        }

        // 判断查询条件是否为列表值
        public boolean isListValue() {
            return listValue;
        }

        // 获取查询条件的类型处理器
        public String getTypeHandler() {
            return typeHandler;
        }

        // 构造函数
        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        // 构造函数
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        // 构造函数
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        // 构造函数
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        // 构造函数
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}